.nolist
#include "ion.inc"
.list
#ifdef TI83P
  .org    progstart-2
  .db     $BB,$6D
#else
  .org    progstart
#endif
  ret				
  jr      nc,Starcraft_Mineral_Simulator
  .db     "Starcraft Mineral Sim",0

#define inc_ix_5 inc ix \ inc ix \ inc ix \ inc ix \ inc ix

mousex  = SafeRam1
mousey  = SafeRam1+1
mouse   = SafeRam1+2
m_drone = SafeRam1+3
drones  = SafeRam1+5
drone1  = SafeRam1+6

Starcraft_Mineral_Simulator:
  ld   a,1
  ld   (mouse),a
  ld   hl,drone1
  ld   (m_drone),hl


  xor  a
  ld   (mousex),a
  ld   a,59
  ld   (mousey),a

  ld   hl,drone_data
  ld   de,drone1
  ld   bc,30
  ldir
  ld   a,6
  ld   (drones),a

  bcall(_clrlcdfull)
draw_all:
  bcall(_grbufclr)  
  ld   a,40
  ld   l,46
  ld   b,16
  ld   c,2
  ld   ix,nexus
  call largesprite

  ld   a,(mousey)
  ld   l,a
  ld   a,(mousex)
  ld   b,5
  ld   ix,mouse_s
  call putsprite


  ld   ix,drone1
  ld   b,(ix-1)
putdrones:
  push bc
  push ix
  call move_and_put
  pop  ix
  inc_ix_5
  pop  bc
  djnz putdrones

  ld   a,(mouse)
  or   a
  jp   nz,next_mouse_check

  ld   a,(m_drone)
  ld   l,0
  ld   b,10
  ld   c,2
  ld   ix,mineral_box
  call largesprite
  jp   done_mouse

next_mouse_check:
  dec  a
  jp   nz,next_mouse_check_1

  ld   hl,m_drone
  bcall(_ldhlind)
  inc  hl
  ld   a,(hl)
  sub  2
  inc  hl
  ld   l,(hl)
  dec  l
  dec  l
  ld   b,11
  ld   c,2
  ld   ix,drone_box
  call largesprite
  jp   done_mouse 
  
next_mouse_check_1:
  dec  a
  jp   nz,done_mouse
  ld   a,38
  ld   l,44
  ld   b,20
  ld   c,3
  ld   ix,nexus_box
  call largesprite

done_mouse:
  xor  a
  ld   b,6
mineral_ones:
  push bc
  push af
  ld   l,2
  ld   b,6
  ld   c,2
  ld   ix,mineral_one
  call largesprite
  pop  af
  add  a,16
  pop  bc
  djnz mineral_ones

;  pop  iy
  call ionfastcopy

keyloop:
  ld   a,0ffh
  out  (1),a
  ld   a,0bfh
  out  (1),a
  in   a,(1)
  cp   223
  jp   z,mouse_click
  ld   a,0ffh
  out  (1),a
  ld   a,0fdh
  out  (1),a
  in   a,(1)
  cp   191
  ret  z
  ld   a,0ffh
  out  (1),a
  ld   a,0feh
  out  (1),a
  in   a,(1)
  cp   254
  jr   z,mouse_down
  cp   253
  jr   z,mouse_left
  cp   251
  jr   z,Mouse_right
  cp   247
  jr   z,mouse_up
  cp   252
  jr   z,mouse_down_left
  cp   250
  jr   z,mouse_down_right
  cp   245
  jr   z,mouse_up_left
  cp   243
  jp   nz,draw_all

mouse_up_right:
  call arrow_right
mouse_up:
  call arrow_up
  jp   draw_all
mouse_down_left:
  call arrow_left
mouse_down:
  call arrow_down
  jp   draw_all
mouse_up_left:
  call arrow_up
mouse_left:
  call arrow_left
  jp   draw_all
mouse_down_right:
  call arrow_down
mouse_right:
  call arrow_right
  jp   draw_all

arrow_right:
  ld   a,(mousex)
  cp   91
  ret  z
  inc  a
  ld   (mousex),a
  ret
arrow_left:
  ld   a,(mousex)
  or   a
  ret  z
  dec  a
  ld   (mousex),a
  ret
arrow_down:
  ld   a,(mousey)
  cp   59
  ret  z
  inc  a
  ld   (mousey),a
  ret
arrow_up:
  ld   a,(mousey)
  or   a
  ret  z
  dec  a
  ld   (mousey),a
  ret
mouse_click:
  ld   ix,drone1
  ld   b,(ix-1)
  ld   hl,(mousex)

  ld   a,8
  cp   h
  jp   p,clicked_minerals

  ld   a,h
  cp   48
  jp   m,check_drones
  
  ld   a,l
  cp   40
  jp   m,check_drones
  cp   57
  jp   m,clicked_nexus
  
check_drones:
  ld   a,(ix+1)
  cp   l
  jp   p,rcheck_drones
  add  a,7
  cp   l
  jp   m,rcheck_drones
  ld   a,(ix+2)
  cp   h
  jp   p,rcheck_drones
  add  a,7
  cp   h
  jp   m,rcheck_drones
  ld   (m_drone),ix
  ld   a,1
  ld   (mouse),a
  jp   draw_all

rcheck_drones:
  ld   de,5
  add  ix,de
  djnz check_drones
  jp   draw_all

clicked_minerals:
  xor  a
  ld   (mouse),a
  ld   a,(mousex)
  cp   15
  jp   p,next1
  xor  a
  ld   (m_drone),a
  jp   draw_all
next1:
  cp   31
  jp   p,next2
  ld   a,16
  ld   (m_drone),a
  jp   draw_all
next2:
  cp   47
  jp   p,next3
  ld   a,32
  ld   (m_drone),a
  jp   draw_all
next3:
  cp   63
  jp   p,next4
  ld   a,48
  ld   (m_drone),a
  jp   draw_all
next4:
  cp   79
  jp   p,next5
  ld   a,64
  ld   (m_drone),a
  jp   draw_all
next5:
  ld   a,80
  ld   (m_drone),a
  jp   draw_all

clicked_nexus:
  ld   a,2
  ld   (mouse),a
  jp   draw_all

move_and_put:
  ld   a,(ix)
  or   a
  jp   nz,move_down
  ld   hl,drone_up         ;start by loading the up sprite
  ld   a,(ix+1)            ;load a with drone's x
  cp   (ix+3)              ;compare with destination x
  jp   z,move_up
  jp   p,move_left         ;to the right of dest. x?  go to move_left
move_right:
  ld   hl,drone_right
  inc  (ix+1)

  ld   a,(ix+2)
  cp   8
  jp   z,done_put_drone

  ld   hl,drone_up_right
  dec  (ix+2)
  jp   done_put_drone
move_up:
                           ;else for now, just move up, IF NECESSARY
  ld   a,(ix+2)            ;load a with drone's y
  cp   8                   ;at mineral field?
  jp   z,switch_and_put
                           ;else
  dec  (ix+2)              ;decrease the y coordinate
  jp   done_put_drone      ;put the drone

move_left:
  ld   hl,drone_left       ;make the drone's sprite be left...
  dec  (ix+1)              ;subtract 1 from the x coordinate

  ld   a,(ix+2)            ;load a with the y coordinate
  cp   8                   ;at mineral field?
  jp   z,done_put_drone    ;just move left then, put the drone!
                           ;else
  ld   hl,drone_up_left    ;load ix with the up_left coordinate AND
  dec  (ix+2)              ;decrease the y coordinate
  jp   done_put_drone

move_down:
  ld   hl,drone_down
  ld   a,(ix+1)
  cp   45
  jp   z,move_down_2
  jp   p,move_left_2
move_right_2:
  ld   hl,drone_right
  inc  (ix+1)

  ld   a,(ix+2)
  cp   39
  jp   z,done_put_drone

  ld   hl,drone_down_right
  inc  (ix+2)
  jp   done_put_drone
move_down_2:
  ld   a,(ix+2)
  cp   39
  jp   z,switch_and_put2
  inc  (ix+2)
  jp   done_put_drone

move_left_2:
  ld   hl,drone_left
  dec  (ix+1)
  ld   a,(ix+2)
  cp   39
  jp   z,done_put_drone

  ld   hl,drone_down_left
  inc  (ix+2)
  jp   done_put_drone
switch_and_put:
  ld   a,10
  cp   (ix+4)
  jp   nz,stay_at_minerals
  inc  (ix)
  ld   (ix+4),0
  jp   done_put_drone
stay_at_minerals:
  inc  (ix+4)
  jp   done_put_drone
switch_and_put2:
  dec  (ix)
done_put_drone:
  ld   a,(ix+1)
  ld   c,(ix+2)
  push hl
  pop  ix
  ld   l,c
  ld   b,7
  call putsprite
  ret



drone_data:   .db 0,45,39,4,0
              .db 0,10,10,20,0
              .db 0,36,12,36,0
              .db 0,89,57,52,0
              .db 0,80,35,68,0
              .db 0,45,39,84,0

;direction, X, Y, mineral location, minerals?

;-----> Draw a sprite
; b=size of sprite
; l=yc
; a=xc
; ix holds pointer
putSprite:
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
putSpriteLoop1:
sl1:	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,putSpriteSkip1
putSpriteLoop2:
	srl	d
	rr	e
	dec	a
	jr	nz,putSpriteLoop2
putSpriteSkip1:
	ld	a,(hl)
	or	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	or	e
	ld	(hl),a
	ld	de,$0B
	add	hl,de
	inc	ix
	djnz	putSpriteLoop1
	ret
;-----> Draw a picture
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
largeSprite:
	di
	ex	af,af'
	ld	a,c
	push	af
	ex	af,af'
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,gbuf
	add	hl,de
largeSpriteLoop1:
	push	hl
largeSpriteLoop2:
	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,largeSpriteSkip1
largeSpriteLoop3:
	srl	d
	rr	e
	dec	a
	jr	nz,largeSpriteLoop3
largeSpriteSkip1:
	ld	a,(hl)
	or	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	or	e
	ld	(hl),a
	inc	ix
	ex	af,af'
	dec	a
	push	af
	ex	af,af'
	pop	af
	jr	nz,largeSpriteLoop2
	pop	hl
	pop	af
	push	af
	ex	af,af'
	ld	de,$0C
	add	hl,de
	djnz	largeSpriteLoop1
	pop	af
	ret

; Sprite data for mineral
mineral:
.db $18
.db $24
.db $66
.db $99
.db $99
.db $66
.db $24
.db $18
nexus:
.db $FF, $FF
.db $80, $01
.db $80, $01
.db $A5, $D5
.db $B5, $15
.db $BD, $89
.db $AD, $15
.db $A5, $D5
.db $80, $01
.db $8A, $E1
.db $8A, $81
.db $8A, $E1
.db $8A, $21
.db $8E, $E1
.db $80, $01
.db $FF, $FF

mineral_one:
.db $02, $04
.db $2D, $5A
.db $51, $A6
.db $5E, $AA
.db $54, $AA
.db $7F, $FE

; Sprite data for drone_left
drone_left:
.db $38
.db $7C
.db $FE
.db $1E
.db $FE
.db $7C
.db $38
; Sprite data for drone_right
drone_right:
.db $38
.db $7C
.db $FE
.db $F0
.db $FE
.db $7C
.db $38
; Sprite data for drone_up
drone_up:
.db $28
.db $6C
.db $EE
.db $FE
.db $FE
.db $7C
.db $38
; Sprite data for drone_down
drone_down:
.db $38
.db $7C
.db $FE
.db $FE
.db $EE
.db $6C
.db $28
; Sprite data for drone_down_right
drone_down_right:
.db $38
.db $7C
.db $FE
.db $EE
.db $F6
.db $78
.db $38
; Sprite data for drone_up_left
drone_up_left:
.db $38
.db $3C
.db $DE
.db $EE
.db $FE
.db $7C
.db $38
; Sprite data for drone_up_right
drone_up_right:
.db $38
.db $78
.db $F6
.db $EE
.db $FE
.db $7C
.db $38
; Sprite data for drone_down_left
drone_down_left:
.db $38
.db $7C
.db $FE
.db $EE
.db $DE
.db $3C
.db $38
mouse_s:
.db %11110000 ;5x5
.db %11100000
.db %11110000
.db %10111000
.db %00010000
drone_box:
.db %11111111,%11100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %10000000,%00100000
.db %11111111,%11100000
nexus_box:
.db %11111111,%11111111,%11110000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %10000000,%00000000,%00010000
.db %11111111,%11111111,%11110000
mineral_box:
.db %11111111,%11111111
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %10000000,%00000001
.db %11111111,%11111111


.end
END